#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

#################################################################################
## Coban - Module rutilisables                                                ## 
## Copyright (C) 2008  Stphan GURIN                                          ##
## contact : setthe@tuxfamily.org                                              ##
##                                                                             ##
## This program is free software; you can redistribute it and/or               ##
## modify it under the terms of the GNU General Public License                 ##
## as published by the Free Software Foundation; either version 2              ##
## of the License, or (at your option) any later version.                      ##
##                                                                             ##
## This program is distributed in the hope that it will be useful,             ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of              ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ##
## GNU General Public License for more details.                                ##
##                                                                             ##
## You should have received a copy of the GNU General Public License           ##
## along with this program; if not, write to the Free Software                 ##
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ##
#################################################################################

import wx
import string, os

#------------ VARIABLES GLOBALES --------------------------------------

favicon = "images/coban.ico"
logo = "images/coban.png"

# ---> POUR INSTALLATION PAR LE SCRIPT SHELL LINUX

#path = os.getcwd()
#os.chdir(path)
#favicon = path+"/.coban/images/coban.ico"
#logo = path+"/.coban/images/coban.png"

#------------ CLASSES -------------------------------------------------

class ValidDigitPoint(wx.PyValidator):
    """ uniquement des digits et le . """
    def __init__(self):
        wx.PyValidator.__init__(self)
        self.Bind(wx.EVT_CHAR, self.OnChar)

    def Clone(self):
        return ValidDigitPoint()

    def Validate(self, win):
        tc = self.GetWindow()
        val = tc.GetValue()
        
        for x in val:
            if x not in string.digits+".":
                return False
            
        return True

    def OnChar(self, event):
        key = event.GetKeyCode()
        
        if key < wx.WXK_SPACE or key == wx.WXK_DELETE or key > 255:
            event.Skip()
            return
        
        if chr(key) in string.digits+".":
            event.Skip()
            return
        
        if not wx.Validator_IsSilent():
            wx.Bell()
            
        return
    
#------------- DFINITIONS --------------------------------------------

def icone(dlg):
    """ Insre l'icone de l'application sur les fentres cres """
    icon = wx.Icon(favicon, wx.BITMAP_TYPE_ICO)
    dlg.SetIcon(icon)
    
#---------------------------------------------------------------------------
    
def testFich(f):
    """teste si le fichier existe - sinon le cre """
    try : # essaye d'ouvrir le fichier 
        fich = open(f, 'r')
        fich.close()
        return 1
    except : # si le fichier n'existe pas, on le cre
        wx.MessageBox(u"Fichier %s inexistant !\nCration d'un nouveau fichier..."%f, 
                      'Erreur !')
        fich = open(f, "w")
        fich.close()
        return 0



    
#----------------------------------------------------------------------

def testFloat(entree, valdef = 0):
    """
    Teste si la valeur entree peut tre convertie en entier, sinon affiche un messageBox d'erreur.
    Si OK retourne la valeur au format int.
    Sinon, retourne la valeur valdef (0 par dfaut)
    """
    try:
        val = float(entree.GetValue())
        entree.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_WINDOW))
        entree.Refresh()
        return val
    except :
        wx.MessageBox(u"La valeur entre est incorrecte !\n"
                      u"et doit tre de la forme nn.n\n"
                      u"\nLe calcul sera erron !!!"
                      , "Erreur")
        entree.SetBackgroundColour("pink")
        entree.SetFocus()
        entree.Refresh()
        return valdef

#----------------------------------------------------------------------
